
-- OnShow
function MerchConfigFrame_OnShow()
	-- make sure our profile has been loaded
	if ( not MerchConfig_VariablesLoaded ) then -- config not loaded
		this:Hide(); -- hide our config pane
		return;
	end
	-- read settings from profile, and change our checkbuttons and slider to represent them

	getglobal(this:GetName().."CheckButtonAutoRepair"):SetChecked( MerchConfig[RealmPlayer].MHAutoRepair );		
	getglobal(this:GetName().."CheckButtonAutoVendor"):SetChecked( MerchConfig[RealmPlayer].MHAutoVendor );
	getglobal(this:GetName().."CheckButtonAnnounceRepair"):SetChecked( MerchConfig[RealmPlayer].MHAnnounceRepair );
	getglobal(this:GetName().."CheckButtonVendorList"):SetChecked( MerchConfig[RealmPlayer].MHVendorList );
	getglobal(this:GetName().."CheckButtonVendorTotal"):SetChecked( MerchConfig[RealmPlayer].MHVendorTotal );
	getglobal(this:GetName().."CheckButtonMerchantBags"):SetChecked( MerchConfig[RealmPlayer].MHMerchantBags );
	getglobal(this:GetName().."CheckButtonMailBags"):SetChecked( MerchConfig[RealmPlayer].MHMailBags );
	getglobal(this:GetName().."CheckButtonAuctionBags"):SetChecked( MerchConfig[RealmPlayer].MHAuctionBags );
	getglobal(this:GetName().."CheckButtonBankBags"):SetChecked( MerchConfig[RealmPlayer].MHBankBags );
	getglobal(this:GetName().."CheckButtonGuildBankBags"):SetChecked( MerchConfig[RealmPlayer].MHGuildBankBags );
	getglobal(this:GetName().."CheckButtonGuildBankRepair"):SetChecked( MerchConfig[RealmPlayer].MHGuildBankRepair );
	getglobal(this:GetName().."CheckButtonTradeBags"):SetChecked( MerchConfig[RealmPlayer].MHTradeBags );
end

-- OnClick
function MerchConfigOptions_OnClick() 
	-- make sure our profile has been loaded
	if ( not MerchConfig_VariablesLoaded ) then -- config not loaded
		this:GetParent():Hide(); -- hide our config pane
		return;
	end
	-- read setting out of checkbox and put into profile
	if ( this:GetName() == (this:GetParent():GetName().."CheckButtonAutoRepair" ) ) then
		MerchConfig[RealmPlayer].MHAutoRepair = this:GetChecked(); -- set profile
	elseif ( this:GetName() == (this:GetParent():GetName().."CheckButtonAutoVendor" ) ) then
		MerchConfig[RealmPlayer].MHAutoVendor = this:GetChecked();
	elseif ( this:GetName() == (this:GetParent():GetName().."CheckButtonAnnounceRepair" ) ) then
		MerchConfig[RealmPlayer].MHAnnounceRepair = this:GetChecked();
	elseif ( this:GetName() == (this:GetParent():GetName().."CheckButtonVendorList" ) ) then
		MerchConfig[RealmPlayer].MHVendorList = this:GetChecked();
	elseif ( this:GetName() == (this:GetParent():GetName().."CheckButtonVendorTotal" ) ) then
		MerchConfig[RealmPlayer].MHVendorTotal = this:GetChecked();
	elseif ( this:GetName() == (this:GetParent():GetName().."CheckButtonMerchantBags" ) ) then
		MerchConfig[RealmPlayer].MHMerchantBags = this:GetChecked();
	elseif ( this:GetName() == (this:GetParent():GetName().."CheckButtonMailBags" ) ) then
		MerchConfig[RealmPlayer].MHMailBags = this:GetChecked();
	elseif ( this:GetName() == (this:GetParent():GetName().."CheckButtonAuctionBags" ) ) then
		MerchConfig[RealmPlayer].MHAuctionBags = this:GetChecked();
	elseif ( this:GetName() == (this:GetParent():GetName().."CheckButtonBankBags" ) ) then
		MerchConfig[RealmPlayer].MHBankBags = this:GetChecked();
	elseif ( this:GetName() == (this:GetParent():GetName().."CheckButtonGuildBankBags" ) ) then
		MerchConfig[RealmPlayer].MHGuildBankBags = this:GetChecked();
	elseif ( this:GetName() == (this:GetParent():GetName().."CheckButtonGuildBankRepair" ) ) then
		MerchConfig[RealmPlayer].MHGuildBankRepair = this:GetChecked();
	elseif ( this:GetName() == (this:GetParent():GetName().."CheckButtonTradeBags" ) ) then
		MerchConfig[RealmPlayer].MHTradeBags = this:GetChecked();
	end
end

