-- Settings
RealmPlayer = GetCVar("realmName").. ", "..UnitName("player");
MerchConfig_VariablesLoaded = false;
MERCHANTHELPER_VERSION = "V1.0 for WoW Build 3.1.1"

local MerchConfig_MHAutoRepair = false;
local MerchConfig_MHAnnounceRepair = false;
local MerchConfig_MHAutoVendor = false;
local MerchConfig_VendorList = false;
local MerchConfig_VendorTotal = false;
local MerchConfig_MHMerchantBags = false;
local MerchConfig_MHMailBags = false;
local MerchConfig_MHAuctionBags = false;
local MerchConfig_MHBankBags = false;
local MerchConfig_MHGuildBankBags = false;
local MerchConfig_MHGuildBankRepair = false;
local MerchConfig_MHTradeBags = false;

-- OnLoad function
-- Register events, loaded message

function MerchantHelper_OnLoad()
	DEFAULT_CHAT_FRAME:AddMessage("Loaded MerchantHelper " ..MERCHANTHELPER_VERSION);
	DEFAULT_CHAT_FRAME:AddMessage("Type /merch to configure");

	this:RegisterEvent("MERCHANT_SHOW");
	this:RegisterEvent("MERCHANT_CLOSED", arg1);
	this:RegisterEvent("BANKFRAME_OPENED");
	this:RegisterEvent("BANKFRAME_CLOSED");
	this:RegisterEvent("AUCTION_HOUSE_SHOW");
	this:RegisterEvent("AUCTION_HOUSE_CLOSED");
	this:RegisterEvent("GUILDBANKFRAME_OPENED");
	this:RegisterEvent("GUILDBANKFRAME_CLOSED");
	this:RegisterEvent("MAIL_SHOW");
	this:RegisterEvent("MAIL_CLOSED");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("TRADE_SHOW");
	this:RegisterEvent("TRADE_CLOSED");

	SlashCmdList["MERCHANTHELPER"] = MHSlashCmdFunction;
	SLASH_MERCHANTHELPER1 = "/merch";
	SLASH_MERCHANTHELPER2 = "/merchanthelper";
	SLASH_MERCHANTHELPER3 = "/mhconfig";
end

function MHSlashCmdFunction()
	MerchConfigFrame:Show();
end

function MerchantHelper_OnEvent(self, event, ...)
	if ( event == "VARIABLES_LOADED" ) then
		MerchantHelper_VARIABLES_LOADED();
	end
	if ( event == "MERCHANT_SHOW") then
		local isRepairer = CanMerchantRepair();
		if ( MerchConfig[RealmPlayer].MHMerchantBags ) then
			OpenAllBags(true)
		end
		if ( MerchConfig[RealmPlayer].MHAutoVendor ) then
			MerchAutoVendor()
		end
		if ( isRepairer and MerchConfig[RealmPlayer].MHAutoRepair ) then
			MerchRepair()
		end
	end

	if ( event == "MAIL_SHOW" and MerchConfig[RealmPlayer].MHMailBags ) then
		OpenAllBags(true)
	end
	if ( event == "AUCTION_HOUSE_SHOW" and MerchConfig[RealmPlayer].MHAuctionBags ) then
		OpenAllBags(true)
	end
	if ( event == "BANKFRAME_OPENED" and MerchConfig[RealmPlayer].MHBankBags ) then
		OpenAllBags(true)
	end
	if ( event == "GUILDBANKFRAME_OPENED" and MerchConfig[RealmPlayer].MHGuildBankBags ) then
		OpenAllBags(true)
	end
	if ( event == "TRADE_SHOW" and MerchConfig[RealmPlayer].MHTradeBags ) then
		OpenAllBags(true)
	end
	if ( event == "MERCHANT_CLOSED" and MerchConfig[RealmPlayer].MHMerchantBags ) then
		MerchCloseBags();
	end
	if ( event == "MAIL_CLOSED" and MerchConfig[RealmPlayer].MHMailBags ) then
		MerchCloseBags();
	end
	if ( event == "AUCTION_HOUSE_CLOSED" and MerchConfig[RealmPlayer].MHAuctionBags ) then
		MerchCloseBags();
	end
	if ( event == "BANKFRAME_CLOSED" and MerchConfig[RealmPlayer].MHBankBags ) then
		MerchCloseBags();
	end
	if ( event == "GUILDBANKFRAME_CLOSED" and MerchConfig[RealmPlayer].MHGuildBankBags ) then
		MerchCloseBags();
	end
	if ( event == "TRADE_CLOSED" and MerchConfig[RealmPlayer].MHTradeBags ) then
		MerchCloseBags();
	end
end

function MerchCloseBags()
	ContainerFrame1.backpackWasOpen = nil;
	CloseAllBags()
end

function MerchAutoVendor()
	local itemTotal = 0
	local startBalance = GetMoney();
	for x = 0, 4 do 
		for y = 1, GetContainerNumSlots(x) do
			local b = GetContainerItemLink(x,y);
			if ( b ) then
				local iName, iLink, iRarity = GetItemInfo(b);
				if ( iRarity == 0 ) then
					PickupContainerItem(x,y);
					local texture, itemCount = GetContainerItemInfo(x,y);
					PickupMerchantItem();
					if ( MerchConfig[RealmPlayer].MHVendorList ) then
						DEFAULT_CHAT_FRAME:AddMessage("Item " ..iLink.. " x" ..itemCount.. " sold!");
					end
					itemTotal = itemTotal + 1;
				end
			end
		end
	end

	if ( MerchConfig[RealmPlayer].MHVendorTotal ) then
		if ( itemTotal == 0 ) then
			return;
		else
			DEFAULT_CHAT_FRAME:AddMessage("Total number of items sold: " ..itemTotal );
		end
	elseif ( not MerchConfig[RealmPlayer].MHVendorTotal ) then
		return;
	end
end

function MerchRepair()
	local repairAllCost, canRepair = GetRepairAllCost();
	local playerMoney = GetMoney();
	if not canRepair then
		return;
	elseif ( canRepair and not MerchConfig[RealmPlayer].MHGuildBankRepair ) then
		if ( playerMoney > repairAllCost ) then
			RepairAllItems();
			if ( MerchConfig[RealmPlayer].MHAnnounceRepair ) then
				local TotalValue = repairAllCost;  -- taken from http://www.wowwiki.com/API_GetMoney
				local TGold = tonumber(string.sub(TotalValue,1,-5)) if TGold == nil or TGold == 0 then TGold = "" else TGold = (TGold.."g, ") end
				local TSilver = tonumber(string.sub(TotalValue,-4,-3)) if TSilver == nil or TSilver == 0 then TSilver = "" else TSilver = (TSilver.."s, ") end
				local TCopper = tonumber(string.sub(TotalValue,-2,-1)) if TCopper == nil or TCopper == 0 then TCopper = "" else TCopper = (TCopper.."c") end
				DEFAULT_CHAT_FRAME:AddMessage("Repairs made: " ..TGold..TSilver..TCopper.. "!", 1, 0, 0);
			elseif ( not MerchConfig[RealmPlayer].MHAnnounceRepair ) then
				return;
			end
		elseif ( playerMoney < repairAllCost ) then
			DEFAULT_CHAT_FRAME:AddMessage("Insufficient funds to make repairs", 1, 0, 0);
		elseif ( playerMoney == repairAllCost ) then
			DEFAULT_CHAT_FRAME:AddMessage("Total repairs will cost all your available funds, please repair manually", 1, 1, 0);
			DEFAULT_CHAT_FRAME:AddMessage("WHAT ARE THE ODDS OF THAT HAPPENING!", 1, 0, 0);
		end
--  GUILD BANK REPAIR
	elseif ( canRepair and MerchConfig[RealmPlayer].MHGuildBankRepair ) then
		local withdrawLimit = GetGuildBankWithdrawMoney();
		local guildRepair = CanGuildBankRepair();
		local gbBalance = GetGuildBankMoney();
		local gbAvailable = min(withdrawLimit, gbBalance);
		if ( MerchConfig[RealmPlayer].MHGuildBankRepair and ( not guildRepair ) ) then
			DEFAULT_CHAT_FRAME:AddMessage("You do not have authority to repair using guild funds, or are not in a guild.  Please type /merch to update your configuration options", 0, 1, 0);
		elseif ( gbAvailable > repairAllCost ) then
			RepairAllItems(1);
			if ( MerchConfig[RealmPlayer].MHAnnounceRepair ) then
				local TotalValue = repairAllCost;  -- taken from http://www.wowwiki.com/API_GetMoney
				local TGold = tonumber(string.sub(TotalValue,1,-5)) if TGold == nil or TGold == 0 then TGold = "" else TGold = (TGold.."g, ") end
				local TSilver = tonumber(string.sub(TotalValue,-4,-3)) if TSilver == nil or TSilver == 0 then TSilver = "" else TSilver = (TSilver.."s, ") end
				local TCopper = tonumber(string.sub(TotalValue,-2,-1)) if TCopper == nil or TCopper == 0 then TCopper = "" else TCopper = (TCopper.."c") end
				DEFAULT_CHAT_FRAME:AddMessage("Repairs made using Guild Bank funds: " ..TGold..TSilver..TCopper.. "!", 0, 1, 0);
			end
		elseif ( gbAvailable < repairAllCost ) then
			DEFAULT_CHAT_FRAME:AddMessage("Insufficient guild bank funds to make repairs", 0, 1, 0);
		elseif ( gbAvailable == repairAllCost ) then
			DEFAULT_CHAT_FRAME:AddMessage("Total repairs will use the remainder of your guild bank withdrawal balance, please repair manually", 0, 1, 0);
			DEFAULT_CHAT_FRAME:AddMessage("WHAT ARE THE ODDS OF THAT HAPPENING!", 0, 1, 0);
		end
	end
end

---------------------------------------------------
--- Set up for Options Menu & Saved Variables -----
---------------------------------------------------

function MerchantHelper_VARIABLES_LOADED()

	if ( not MerchConfig ) then
		MerchConfig = {};
	end
	if ( not MerchConfig[RealmPlayer] ) then
		MerchConfig[RealmPlayer] = {};
	end
	if ( not MerchConfig[RealmPlayer].MHAutoRepair ) then
		MerchConfig[RealmPlayer].MHAutoRepair = MerchConfig_MHAutoRepair;
	end
	if ( not MerchConfig[RealmPlayer].MHAnnounceRepair ) then
		MerchConfig[RealmPlayer].MHAnnounceRepair = MerchConfig_AnnounceRepair;
	end
	if ( not MerchConfig[RealmPlayer].MHAutoVendor ) then
		MerchConfig[RealmPlayer].MHAutoVendor = MerchConfig_MHAutoVendor;
	end
	if ( not MerchConfig[RealmPlayer].MHVendorList ) then
		MerchConfig[RealmPlayer].MHVendorList = MerchConfig_MHVendorList;
	end
	if ( not MerchConfig[RealmPlayer].MHVendorTotal ) then
		MerchConfig[RealmPlayer].MHVendorTotal = MerchConfig_MHVendorTotal;
	end
	if ( not MerchConfig[RealmPlayer].MHMerchantBags ) then
		MerchConfig[RealmPlayer].MHMerchantBags = MerchConfig_MHMerchantBags;
	end
	if ( not MerchConfig[RealmPlayer].MHMerchantBags ) then
		MerchConfig[RealmPlayer].MHMailBags = MerchConfig_MHMailBags;
	end
	if ( not MerchConfig[RealmPlayer].MHAuctionBags ) then
		MerchConfig[RealmPlayer].MHAuctionBags = MerchConfig_MHAuctionBags;
	end
	if ( not MerchConfig[RealmPlayer].MHBankBags ) then
		MerchConfig[RealmPlayer].MHBankBags = MerchConfig_MHBankBags;
	end
	if ( not MerchConfig[RealmPlayer].MHGuildBankBags ) then
		MerchConfig[RealmPlayer].MHGuildBankBags = MerchConfig_MHGuildBankBags;
	end
	if ( not MerchConfig[RealmPlayer].MHGuildBankRepair ) then
		MerchConfig[RealmPlayer].MHGuildBankRepair = MerchConfig_MHGuildBankRepair;
	end
	if ( not MerchConfig[RealmPlayer].MHTradeBags ) then
		MerchConfig[RealmPlayer].MHTradeBags = MerchConfig_MHTradeBags;
	end

	MerchConfig_VariablesLoaded = true;  -- record that variables have been loaded
end

function MerchConfigDefaults()
	if (not MerchConfig_VariablesLoaded ) then
		MerchantHelperFrame:Hide();
		return;
	end

	MerchConfig[RealmPlayer].MHAutoRepair = MerchConfig_MHAutoRepair;
	MerchConfig[RealmPlayer].MHAnnounceRepair = MerchConfig_AnnounceRepair;
	MerchConfig[RealmPlayer].MHAutoVendor = MerchConfig_MHAutoVendor;
	MerchConfig[RealmPlayer].MHVendorList = MerchConfig_VendorList;
	MerchConfig[RealmPlayer].MHVendorTotal = MerchConfig_VendorTotal;
	MerchConfig[RealmPlayer].MHMerchantBags = MerchConfig_MHMerchantBags;
	MerchConfig[RealmPlayer].MHMailBags = MerchConfig_MHMailBags;
	MerchConfig[RealmPlayer].MHAuctionBags = MerchConfig_MHAuctionBags;
	MerchConfig[RealmPlayer].MHBankBags = MerchConfig_MHBankBags;
	MerchConfig[RealmPlayer].MHGuildBankBags = MerchConfig_MHGuildBankBags;
	MerchConfig[RealmPlayer].MHGuildBankRepair = MerchConfig_MHGuildBankRepair;
	MerchConfig[RealmPlayer].MHTradeBags = MerchConfig_MHTradeBags;
end

function MerchConfigEnableAll()
	if (not MerchConfig_VariablesLoaded ) then
		MerchantHelperFrame:Hide();
		return;
	end
	MerchConfig[RealmPlayer].MHAutoRepair = true;
	MerchConfig[RealmPlayer].MHAnnounceRepair = true;
	MerchConfig[RealmPlayer].MHAutoVendor = true;
	MerchConfig[RealmPlayer].MHVendorList = true;
	MerchConfig[RealmPlayer].MHVendorTotal = true;
	MerchConfig[RealmPlayer].MHMerchantBags = true;
	MerchConfig[RealmPlayer].MHMailBags = true;
	MerchConfig[RealmPlayer].MHAuctionBags = true;
	MerchConfig[RealmPlayer].MHBankBags = true;
	MerchConfig[RealmPlayer].MHGuildBankBags = true;
	MerchConfig[RealmPlayer].MHGuildBankRepair = true;
	MerchConfig[RealmPlayer].MHTradeBags = true;
end

